//******************************************************************************
// Projeto - RELOGIO BINARIO (NERD)
// Desenvolvido por Mrcio Jos Soares
//
// Arquivo - relogio_nerd.h - configuraes, definies e variveis globais
//******************************************************************************

//******************************************************************************
// Este arquivo  parte integrante do artigo Relgio Binrio com
// microcontrolador. Maiores informaes sobre o projeto podem ser obtidas
// no referido artigo publicado na Revista Eletronica Total
//******************************************************************************

//******************************************************************************
// O Copyright deste programa est reservado para Mrcio Jos Soares e seu
// contedo est protegido pela Lei de Direitos Autorais LEI N 9.610,
// de 19 de Fevereiro de 1998.  estritamente proibida o uso comercial como
// tambm a publicao total ou parcial dos contedos aqui apresentados
// sem prvia autorizao, por escrito, do autor.
//******************************************************************************

//******************************************************************************
// Arquivos includos neste mdulo
//******************************************************************************
#include <16F628.h>

//******************************************************************************
// Configuraes para o microcontrolador PIC16F628
//******************************************************************************
#use delay(clock=4000000,RESTART_WDT)

#byte PORTA    = 0x05               //endereo do registrador do port A
#byte PORTB    = 0x06               //endereo do registrador do port B

//******************************************************************************
// Configurao dos fuses do microcontrolador PIC16F628
//******************************************************************************
#fuses INTRC_IO,PUT,WDT,NOBROWNOUT,NOMCLR,NOLVP,NOCPD
//INTRC	      Clock interno
//PUT          Ativa tempo de inicializao
//WDT		      Ativa Watch Dog Timer
//NOBROWNOUT	No usa brownout reset
//NOMCLR		   Pino Master Clear usado como pino de I/O
//NOLVP		   No usa baixa voltagem para programao, pino B3 usado como I/O
//NOCPD		   No protege EEPROM

//******************************************************************************
// Definies para o mdulo - relogio_nerd.c
//******************************************************************************

#define  LINHAS   PORTA          //linhas em RA0 a RA3

#define  LIN1     PIN_A0         //linha 1 na matriz
#define  LIN2     PIN_A1         //linha 2 na matriz
#define  LIN3     PIN_A2         //linha 3 na matriz
#define  LIN4     PIN_A3         //linha 4 na matriz

#define  COLUNAS  PORTB          //colunas em RB2 a RB7

#define  COL1     PIN_B2         //coluna 1 na matriz
#define  COL2     PIN_B3         //coluna 2 na matriz
#define  COL3     PIN_B4         //coluna 3 na matriz
#define  COL4     PIN_B5         //coluna 4 na matriz
#define  COL5     PIN_B6         //coluna 5 na matriz
#define  COL6     PIN_B7         //coluna 6 na matriz

#define  AJT1     PIN_A4         //avana tempo a cada 0,3 ms no modo ajuste
#define  AJT2     PIN_A5         //troca de minutos para hora no modo ajuste
#define  F24H     PIN_B1         //define formato 24 horas

#define  HF24     0x17           //23
#define  HF12     0x0C           //12
#define  HI24     0x00           //00
#define  HI12     0x01           //01

//******************************************************************************
// Variveis Globais do mdulo - relogio_nerd.c
//******************************************************************************

unsigned char conta;             //varivel para contar pulsos de int
unsigned char est_ajt;           //varivel da mquina de estados do modo
                                 //ajuste
unsigned char prima;             //determina se ajustou alguma vez
unsigned char hora_final;        //formato da hora a ser mostrada (final)
unsigned char hora_inicial;      //formato da hora a ser mostrada (inicial)

struct tempo{                    //estutura para relgio
   unsigned char horas;          //1 a 24
   unsigned char minutos;        //1 a 60
   unsigned char segundos;       //1 a 60
   } horario;

